package edu.mermet.tp8.aide;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.plaf.SplitPaneUI;
import java.awt.*;
import java.awt.event.*;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.*;

public class Aide extends JDialog {
    JList<Object> maListe;
    JEditorPane droite;
    HashMap<String, String> mapTitreTexte;



    public Aide(JFrame owner) {
        super(owner, "Boîte d'aide", false);
        setLocationRelativeTo(null);

        init();

        pack();
        //setSize(200,200);
        setVisible(true);
    }

    public void init() {
        try {
            Properties propTitre = new Properties();
            Properties propTexte = new Properties();
            Vector cle = new Vector();

            JEditorPane gauche = new JEditorPane("text/html", "");
            FileReader fichier = new FileReader("src/main/ressources/HowTo/titres.properties");
            FileReader fichierTexte = new FileReader("src/main/ressources/HowTo/textes.properties");

            propTitre.load(fichier);
            propTexte.load(fichierTexte);

            ArrayList<String> mesCles = new ArrayList<>();
            mapTitreTexte = new HashMap<>();

            for (Enumeration monEnum = propTitre.propertyNames(); monEnum.hasMoreElements();)
                mesCles.add (monEnum.nextElement().toString());

            for (String elem: mesCles) {
                cle.add(propTitre.getProperty(elem));
                mapTitreTexte.put(propTitre.getProperty(elem), propTexte.getProperty(elem));
            }

            maListe = new JList<>(cle);

            maListe.addListSelectionListener(new ActionListe());

            droite = new JEditorPane("text/html", "<h2>Choisissez une option dans le menu de gauche pour afficher l'aide correspondante.</h2>");

            JSplitPane panneau = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, maListe, droite);
            this.add(panneau, BorderLayout.CENTER);
        }
        catch (Exception e) {
            System.err.println(e.getMessage());
        }
    }

    private class ActionListe implements ListSelectionListener {
        public ActionListe() {

        }

        @Override
        public void valueChanged(ListSelectionEvent e) {
            String attribut = (String) maListe.getSelectedValue();
            droite.setText(mapTitreTexte.get(attribut));
        }
    }


}
